


<!DOCTYPE html>
<html>
<head>
    <meta http-equiv="Content-Type" content="text/html; charset=utf-8">
    
    
    <meta http-equiv="X-UA-Compatible" content="IE=emulateIE7" />
    <title>Coverage for /private/tmp/im/impacket/impacket/Dot11KeyManager.py: 51%</title>
    <link rel="stylesheet" href="style.css" type="text/css">
    
    <script type="text/javascript" src="jquery.min.js"></script>
    <script type="text/javascript" src="jquery.hotkeys.js"></script>
    <script type="text/javascript" src="jquery.isonscreen.js"></script>
    <script type="text/javascript" src="coverage_html.js"></script>
    <script type="text/javascript">
        jQuery(document).ready(coverage.pyfile_ready);
    </script>
</head>
<body class="pyfile">

<div id="header">
    <div class="content">
        <h1>Coverage for <b>/private/tmp/im/impacket/impacket/Dot11KeyManager.py</b> :
            <span class="pc_cov">51%</span>
        </h1>

        <img id="keyboard_icon" src="keybd_closed.png" alt="Show keyboard shortcuts" />

        <h2 class="stats">
            31 statements &nbsp;
            <span class="run hide_run shortkey_r button_toggle_run">18 run</span>
            <span class="mis shortkey_m button_toggle_mis">13 missing</span>
            <span class="exc shortkey_x button_toggle_exc">0 excluded</span>

            
                <span class="par run hide_run shortkey_p button_toggle_par">3 partial</span>
            
        </h2>
    </div>
</div>

<div class="help_panel">
    <img id="panel_icon" src="keybd_open.png" alt="Hide keyboard shortcuts" />
    <p class="legend">Hot-keys on this page</p>
    <div>
    <p class="keyhelp">
        <span class="key">r</span>
        <span class="key">m</span>
        <span class="key">x</span>
        <span class="key">p</span> &nbsp; toggle line displays
    </p>
    <p class="keyhelp">
        <span class="key">j</span>
        <span class="key">k</span> &nbsp; next/prev highlighted chunk
    </p>
    <p class="keyhelp">
        <span class="key">0</span> &nbsp; (zero) top of page
    </p>
    <p class="keyhelp">
        <span class="key">1</span> &nbsp; (one) first highlighted chunk
    </p>
    </div>
</div>

<div id="source">
    <table>
        <tr>
            <td class="linenos">
<p id="n1" class="pln"><a href="#n1">1</a></p>
<p id="n2" class="pln"><a href="#n2">2</a></p>
<p id="n3" class="pln"><a href="#n3">3</a></p>
<p id="n4" class="pln"><a href="#n4">4</a></p>
<p id="n5" class="pln"><a href="#n5">5</a></p>
<p id="n6" class="pln"><a href="#n6">6</a></p>
<p id="n7" class="pln"><a href="#n7">7</a></p>
<p id="n8" class="pln"><a href="#n8">8</a></p>
<p id="n9" class="pln"><a href="#n9">9</a></p>
<p id="n10" class="pln"><a href="#n10">10</a></p>
<p id="n11" class="pln"><a href="#n11">11</a></p>
<p id="n12" class="pln"><a href="#n12">12</a></p>
<p id="n13" class="stm run hide_run"><a href="#n13">13</a></p>
<p id="n14" class="stm run hide_run"><a href="#n14">14</a></p>
<p id="n15" class="stm run hide_run"><a href="#n15">15</a></p>
<p id="n16" class="stm run hide_run"><a href="#n16">16</a></p>
<p id="n17" class="pln"><a href="#n17">17</a></p>
<p id="n18" class="stm run hide_run"><a href="#n18">18</a></p>
<p id="n19" class="pln"><a href="#n19">19</a></p>
<p id="n20" class="stm par run hide_run"><a href="#n20">20</a></p>
<p id="n21" class="stm mis"><a href="#n21">21</a></p>
<p id="n22" class="stm run hide_run"><a href="#n22">22</a></p>
<p id="n23" class="pln"><a href="#n23">23</a></p>
<p id="n24" class="stm run hide_run"><a href="#n24">24</a></p>
<p id="n25" class="stm run hide_run"><a href="#n25">25</a></p>
<p id="n26" class="stm par run hide_run"><a href="#n26">26</a></p>
<p id="n27" class="stm run hide_run"><a href="#n27">27</a></p>
<p id="n28" class="stm run hide_run"><a href="#n28">28</a></p>
<p id="n29" class="pln"><a href="#n29">29</a></p>
<p id="n30" class="stm mis"><a href="#n30">30</a></p>
<p id="n31" class="pln"><a href="#n31">31</a></p>
<p id="n32" class="stm run hide_run"><a href="#n32">32</a></p>
<p id="n33" class="stm mis"><a href="#n33">33</a></p>
<p id="n34" class="stm mis"><a href="#n34">34</a></p>
<p id="n35" class="pln"><a href="#n35">35</a></p>
<p id="n36" class="stm mis"><a href="#n36">36</a></p>
<p id="n37" class="pln"><a href="#n37">37</a></p>
<p id="n38" class="stm run hide_run"><a href="#n38">38</a></p>
<p id="n39" class="stm run hide_run"><a href="#n39">39</a></p>
<p id="n40" class="stm par run hide_run"><a href="#n40">40</a></p>
<p id="n41" class="stm run hide_run"><a href="#n41">41</a></p>
<p id="n42" class="pln"><a href="#n42">42</a></p>
<p id="n43" class="stm mis"><a href="#n43">43</a></p>
<p id="n44" class="pln"><a href="#n44">44</a></p>
<p id="n45" class="stm run hide_run"><a href="#n45">45</a></p>
<p id="n46" class="stm mis"><a href="#n46">46</a></p>
<p id="n47" class="stm mis"><a href="#n47">47</a></p>
<p id="n48" class="stm mis"><a href="#n48">48</a></p>
<p id="n49" class="pln"><a href="#n49">49</a></p>
<p id="n50" class="stm mis"><a href="#n50">50</a></p>
<p id="n51" class="stm mis"><a href="#n51">51</a></p>
<p id="n52" class="stm mis"><a href="#n52">52</a></p>
<p id="n53" class="pln"><a href="#n53">53</a></p>
<p id="n54" class="stm mis"><a href="#n54">54</a></p>

            </td>
            <td class="text">
<p id="t1" class="pln"><span class="com"># SECUREAUTH LABS. Copyright 2018 SecureAuth Corporation. All rights reserved.</span><span class="strut">&nbsp;</span></p>
<p id="t2" class="pln"><span class="com">#</span><span class="strut">&nbsp;</span></p>
<p id="t3" class="pln"><span class="com"># This software is provided under under a slightly modified version</span><span class="strut">&nbsp;</span></p>
<p id="t4" class="pln"><span class="com"># of the Apache Software License. See the accompanying LICENSE file</span><span class="strut">&nbsp;</span></p>
<p id="t5" class="pln"><span class="com"># for more information.</span><span class="strut">&nbsp;</span></p>
<p id="t6" class="pln"><span class="com">#</span><span class="strut">&nbsp;</span></p>
<p id="t7" class="pln"><span class="com"># Description:</span><span class="strut">&nbsp;</span></p>
<p id="t8" class="pln"><span class="com">#  IEEE 802.11 Network packet codecs.</span><span class="strut">&nbsp;</span></p>
<p id="t9" class="pln"><span class="com">#</span><span class="strut">&nbsp;</span></p>
<p id="t10" class="pln"><span class="com"># Author:</span><span class="strut">&nbsp;</span></p>
<p id="t11" class="pln"><span class="com">#  Gustavo Moreira</span><span class="strut">&nbsp;</span></p>
<p id="t12" class="pln"><span class="strut">&nbsp;</span></p>
<p id="t13" class="stm run hide_run"><span class="key">from</span> <span class="nam">array</span> <span class="key">import</span> <span class="nam">array</span><span class="strut">&nbsp;</span></p>
<p id="t14" class="stm run hide_run"><span class="key">class</span> <span class="nam">KeyManager</span><span class="op">:</span><span class="strut">&nbsp;</span></p>
<p id="t15" class="stm run hide_run">    <span class="key">def</span> <span class="nam">__init__</span><span class="op">(</span><span class="nam">self</span><span class="op">)</span><span class="op">:</span><span class="strut">&nbsp;</span></p>
<p id="t16" class="stm run hide_run">        <span class="nam">self</span><span class="op">.</span><span class="nam">keys</span> <span class="op">=</span> <span class="op">{</span><span class="op">}</span><span class="strut">&nbsp;</span></p>
<p id="t17" class="pln"><span class="strut">&nbsp;</span></p>
<p id="t18" class="stm run hide_run">    <span class="key">def</span> <span class="nam">__get_bssid_hasheable_type</span><span class="op">(</span><span class="nam">self</span><span class="op">,</span> <span class="nam">bssid</span><span class="op">)</span><span class="op">:</span><span class="strut">&nbsp;</span></p>
<p id="t19" class="pln">        <span class="com"># List is an unhashable type</span><span class="strut">&nbsp;</span></p>
<p id="t20" class="stm par run hide_run"><span class="annotate short">20&#x202F;&#x219B;&#x202F;21</span><span class="annotate long">line 20 didn't jump to line 21, because the condition on line 20 was never true</span>        <span class="key">if</span> <span class="key">not</span> <span class="nam">isinstance</span><span class="op">(</span><span class="nam">bssid</span><span class="op">,</span> <span class="op">(</span><span class="nam">list</span><span class="op">,</span><span class="nam">tuple</span><span class="op">,</span><span class="nam">array</span><span class="op">)</span><span class="op">)</span><span class="op">:</span><span class="strut">&nbsp;</span></p>
<p id="t21" class="stm mis">            <span class="key">raise</span> <span class="nam">Exception</span><span class="op">(</span><span class="str">'BSSID datatype must be a tuple, list or array'</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t22" class="stm run hide_run">        <span class="key">return</span> <span class="nam">tuple</span><span class="op">(</span><span class="nam">bssid</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t23" class="pln"><span class="strut">&nbsp;</span></p>
<p id="t24" class="stm run hide_run">    <span class="key">def</span> <span class="nam">add_key</span><span class="op">(</span><span class="nam">self</span><span class="op">,</span> <span class="nam">bssid</span><span class="op">,</span> <span class="nam">key</span><span class="op">)</span><span class="op">:</span><span class="strut">&nbsp;</span></p>
<p id="t25" class="stm run hide_run">        <span class="nam">bssid</span><span class="op">=</span><span class="nam">self</span><span class="op">.</span><span class="nam">__get_bssid_hasheable_type</span><span class="op">(</span><span class="nam">bssid</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t26" class="stm par run hide_run"><span class="annotate short">26&#x202F;&#x219B;&#x202F;30</span><span class="annotate long">line 26 didn't jump to line 30, because the condition on line 26 was never false</span>        <span class="key">if</span> <span class="nam">bssid</span> <span class="key">not</span> <span class="key">in</span> <span class="nam">self</span><span class="op">.</span><span class="nam">keys</span><span class="op">:</span><span class="strut">&nbsp;</span></p>
<p id="t27" class="stm run hide_run">            <span class="nam">self</span><span class="op">.</span><span class="nam">keys</span><span class="op">[</span><span class="nam">bssid</span><span class="op">]</span> <span class="op">=</span> <span class="nam">key</span><span class="strut">&nbsp;</span></p>
<p id="t28" class="stm run hide_run">            <span class="key">return</span> <span class="key">True</span><span class="strut">&nbsp;</span></p>
<p id="t29" class="pln">        <span class="key">else</span><span class="op">:</span><span class="strut">&nbsp;</span></p>
<p id="t30" class="stm mis">            <span class="key">return</span> <span class="key">False</span><span class="strut">&nbsp;</span></p>
<p id="t31" class="pln"><span class="strut">&nbsp;</span></p>
<p id="t32" class="stm run hide_run">    <span class="key">def</span> <span class="nam">replace_key</span><span class="op">(</span><span class="nam">self</span><span class="op">,</span> <span class="nam">bssid</span><span class="op">,</span> <span class="nam">key</span><span class="op">)</span><span class="op">:</span><span class="strut">&nbsp;</span></p>
<p id="t33" class="stm mis">        <span class="nam">bssid</span><span class="op">=</span><span class="nam">self</span><span class="op">.</span><span class="nam">__get_bssid_hasheable_type</span><span class="op">(</span><span class="nam">bssid</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t34" class="stm mis">        <span class="nam">self</span><span class="op">.</span><span class="nam">keys</span><span class="op">[</span><span class="nam">bssid</span><span class="op">]</span> <span class="op">=</span> <span class="nam">key</span><span class="strut">&nbsp;</span></p>
<p id="t35" class="pln"><span class="strut">&nbsp;</span></p>
<p id="t36" class="stm mis">        <span class="key">return</span> <span class="key">True</span><span class="strut">&nbsp;</span></p>
<p id="t37" class="pln"><span class="strut">&nbsp;</span></p>
<p id="t38" class="stm run hide_run">    <span class="key">def</span> <span class="nam">get_key</span><span class="op">(</span><span class="nam">self</span><span class="op">,</span> <span class="nam">bssid</span><span class="op">)</span><span class="op">:</span><span class="strut">&nbsp;</span></p>
<p id="t39" class="stm run hide_run">        <span class="nam">bssid</span><span class="op">=</span><span class="nam">self</span><span class="op">.</span><span class="nam">__get_bssid_hasheable_type</span><span class="op">(</span><span class="nam">bssid</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t40" class="stm par run hide_run"><span class="annotate short">40&#x202F;&#x219B;&#x202F;43</span><span class="annotate long">line 40 didn't jump to line 43, because the condition on line 40 was never false</span>        <span class="key">if</span> <span class="nam">bssid</span> <span class="key">in</span> <span class="nam">self</span><span class="op">.</span><span class="nam">keys</span><span class="op">:</span><span class="strut">&nbsp;</span></p>
<p id="t41" class="stm run hide_run">            <span class="key">return</span> <span class="nam">self</span><span class="op">.</span><span class="nam">keys</span><span class="op">[</span><span class="nam">bssid</span><span class="op">]</span><span class="strut">&nbsp;</span></p>
<p id="t42" class="pln">        <span class="key">else</span><span class="op">:</span><span class="strut">&nbsp;</span></p>
<p id="t43" class="stm mis">            <span class="key">return</span> <span class="key">False</span><span class="strut">&nbsp;</span></p>
<p id="t44" class="pln"><span class="strut">&nbsp;</span></p>
<p id="t45" class="stm run hide_run">    <span class="key">def</span> <span class="nam">delete_key</span><span class="op">(</span><span class="nam">self</span><span class="op">,</span> <span class="nam">bssid</span><span class="op">)</span><span class="op">:</span><span class="strut">&nbsp;</span></p>
<p id="t46" class="stm mis">        <span class="nam">bssid</span><span class="op">=</span><span class="nam">self</span><span class="op">.</span><span class="nam">__get_bssid_hasheable_type</span><span class="op">(</span><span class="nam">bssid</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t47" class="stm mis">        <span class="key">if</span> <span class="key">not</span> <span class="nam">isinstance</span><span class="op">(</span><span class="nam">bssid</span><span class="op">,</span> <span class="nam">list</span><span class="op">)</span><span class="op">:</span><span class="strut">&nbsp;</span></p>
<p id="t48" class="stm mis">            <span class="key">raise</span> <span class="nam">Exception</span><span class="op">(</span><span class="str">'BSSID datatype must be a list'</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t49" class="pln"><span class="strut">&nbsp;</span></p>
<p id="t50" class="stm mis">        <span class="key">if</span> <span class="nam">bssid</span> <span class="key">in</span> <span class="nam">self</span><span class="op">.</span><span class="nam">keys</span><span class="op">:</span><span class="strut">&nbsp;</span></p>
<p id="t51" class="stm mis">            <span class="key">del</span> <span class="nam">self</span><span class="op">.</span><span class="nam">keys</span><span class="op">[</span><span class="nam">bssid</span><span class="op">]</span><span class="strut">&nbsp;</span></p>
<p id="t52" class="stm mis">            <span class="key">return</span> <span class="key">True</span><span class="strut">&nbsp;</span></p>
<p id="t53" class="pln"><span class="strut">&nbsp;</span></p>
<p id="t54" class="stm mis">        <span class="key">return</span> <span class="key">False</span><span class="strut">&nbsp;</span></p>

            </td>
        </tr>
    </table>
</div>

<div id="footer">
    <div class="content">
        <p>
            <a class="nav" href="index.html">&#xab; index</a> &nbsp; &nbsp; <a class="nav" href="https://coverage.readthedocs.io">coverage.py v4.5.4</a>,
            created at 2019-09-25 12:47
        </p>
    </div>
</div>

</body>
</html>
